(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common'], factory) :
    (factory((global.ng = global.ng || {}, global.ng['nqx-qrcode-all'] = {}),global.ng.core,global.ng.common));
}(this, (function (exports,core,common) { 'use strict';

    var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var QrCode = require('qrcode');
    var QrCodeAllComponent = /** @class */ (function () {
        function QrCodeAllComponent(renderer) {
            this.renderer = renderer;
            this.qrCodeType = 'url';
            this.qrCodeVersion = '';
            this.width = 11;
            this.margin = 4;
            this.qrScale = 4;
            this.qrCodeECLevel = 'M';
            this.qrCodeValue = 'SK2504 is the best in the world';
            this.qrCodeColorLight = '#ffffff';
            this.qrCodeColorDark = '#000000';
        }
        QrCodeAllComponent.prototype.ngOnInit = function () {
        };
        QrCodeAllComponent.prototype.ngOnChanges = function () {
            this.produceQrCode();
        };
        QrCodeAllComponent.prototype.produceQrCode = function () {
            if (this.qrCodeValue) {
                switch (this.qrCodeType) {
                    case 'canvas':
                        this.createQrCanvas();
                        break;
                    case 'img':
                    case 'url':
                    default:
                        this.createQrUrlImage();
                        break;
                }
            }
            else {
                return;
            }
        };
        QrCodeAllComponent.prototype.createQrCanvas = function () {
            var _this = this;
            var canvasEl = this.renderer.createElement('canvas');
            this.toCanvasQr(canvasEl).then(function (data) {
                _this.renderElement(canvasEl);
            }).catch(function (error) {
                console.error(error);
            });
        };
        QrCodeAllComponent.prototype.createQrUrlImage = function () {
            var _this = this;
            var imgEl = this.renderer.createElement('img');
            this.toImgUrlQr().then(function (url) {
                imgEl.setAttribute('src', url);
                _this.renderElement(imgEl);
            }).catch(function (err) {
                console.error(err);
            });
        };
        QrCodeAllComponent.prototype.toCanvasQr = function (canvasEl) {
            var _this = this;
            return new Promise(function (resolve, reject) {
                QrCode.toCanvas(canvasEl, _this.qrCodeValue, {
                    version: _this.qrCodeVersion,
                    errorCorrectionLevel: _this.qrCodeECLevel,
                    width: _this.width,
                    margin: _this.margin,
                    scale: _this.qrScale,
                    color: {
                        light: _this.qrCodeColorLight,
                        dark: _this.qrCodeColorDark
                    }
                }, function (error) {
                    error ? reject(error) : resolve('success');
                });
            });
        };
        QrCodeAllComponent.prototype.toImgUrlQr = function () {
            var _this = this;
            return new Promise(function (resolve, reject) {
                QrCode.toDataUrl(_this.qrCodeValue, {
                    version: _this.qrCodeVersion,
                    errorCorrectionLevel: _this.qrCodeECLevel,
                    width: _this.width,
                    margin: _this.margin,
                    scale: _this.qrScale,
                    color: {
                        light: _this.qrCodeColorLight,
                        dark: _this.qrCodeColorDark
                    }
                }, function (error, url) {
                    error ? reject(error) : resolve(url);
                });
            });
        };
        QrCodeAllComponent.prototype.renderElement = function (element) {
            if (this.qrCodeDiv) {
                for (var _i = 0, _a = this.qrCodeDiv.nativeElement.childNodes; _i < _a.length; _i++) {
                    var child = _a[_i];
                    this.renderer.removeChild(this.qrCodeDiv.nativeElement, child);
                }
                this.renderer.appendChild(this.qrCodeDiv.nativeElement, element);
            }
        };
        __decorate([
            core.Input('qrCodeType')
        ], QrCodeAllComponent.prototype, "qrCodeType", void 0);
        __decorate([
            core.Input('qrCodeVersion')
        ], QrCodeAllComponent.prototype, "qrCodeVersion", void 0);
        __decorate([
            core.Input('qrCodeStyle')
        ], QrCodeAllComponent.prototype, "qrCodeClass", void 0);
        __decorate([
            core.Input('width')
        ], QrCodeAllComponent.prototype, "width", void 0);
        __decorate([
            core.Input('margin')
        ], QrCodeAllComponent.prototype, "margin", void 0);
        __decorate([
            core.Input('scale')
        ], QrCodeAllComponent.prototype, "qrScale", void 0);
        __decorate([
            core.Input('qrCodeECLevel')
        ], QrCodeAllComponent.prototype, "qrCodeECLevel", void 0);
        __decorate([
            core.Input('qrCodeValue')
        ], QrCodeAllComponent.prototype, "qrCodeValue", void 0);
        __decorate([
            core.Input('qrCodeColorLight')
        ], QrCodeAllComponent.prototype, "qrCodeColorLight", void 0);
        __decorate([
            core.Input('qrCodeColorDark')
        ], QrCodeAllComponent.prototype, "qrCodeColorDark", void 0);
        __decorate([
            core.ViewChild('qrCodeDiv')
        ], QrCodeAllComponent.prototype, "qrCodeDiv", void 0);
        QrCodeAllComponent = __decorate([
            core.Component({
                selector: 'qr-code-all',
                template: '<div [class]="qrCodeClass" #qrCodeDiv></div>'
            })
        ], QrCodeAllComponent);
        return QrCodeAllComponent;
    }());

    var __decorate$1 = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var QrCodeAllModule = /** @class */ (function () {
        function QrCodeAllModule() {
        }
        QrCodeAllModule_1 = QrCodeAllModule;
        QrCodeAllModule.forRoot = function () {
            return {
                ngModule: QrCodeAllModule_1,
                providers: []
            };
        };
        var QrCodeAllModule_1;
        QrCodeAllModule = QrCodeAllModule_1 = __decorate$1([
            core.NgModule({
                declarations: [
                    QrCodeAllComponent
                ],
                imports: [
                    common.CommonModule
                ],
                exports: [
                    QrCodeAllComponent
                ]
            })
        ], QrCodeAllModule);
        return QrCodeAllModule;
    }());

    exports.QrCodeAllComponent = QrCodeAllComponent;
    exports.QrCodeAllModule = QrCodeAllModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
